(function( $ ) {
  'use strict';

  $(document).ready(function($) {

    var postAction = function(action, data) {
      return $.post(ajaxurl, {action: action, data: data});
    };

    $('#sk_reload_all').click(function(event) {
      event.preventDefault();
      postAction('sk_reload_all').done(function(response) {
        location.reload();
      });
    });

  });
})( jQuery );

( function( wp ) {
  var SpeechKitButton = function( props ) {
    var shortcodeStart = '[SpeechKit-Start]';
    var shortcodeEnd = '[SpeechKit-Stop]';
    var shortcodeStartLength = shortcodeStart.length;
    var shortcodeEndLength = shortcodeEnd.length;
    var shortcodesLength = shortcodeStartLength + shortcodeEndLength;
    return wp.element.createElement(
      wp.editor.RichTextToolbarButton, {
        icon: 'controls-volumeon',
        title: 'SpeechKit',
        onClick: function() {
          ifStart = props.value.text.substring(props.value.start, props.value.start + shortcodeStartLength);
          ifEnd = props.value.text.substring(props.value.end - shortcodeEndLength, props.value.end);
          if( ifStart == shortcodeStart && ifEnd == shortcodeEnd ){
            props.value.text = props.value.text.substring(0, props.value.start) + props.value.text.substring(props.value.start + shortcodeStartLength, props.value.end - shortcodeEndLength) + props.value.text.substring(props.value.end, props.value.formats.length);
            props.value.formats.length -= shortcodesLength;
            props.value.replacements.length -= shortcodesLength;
            props.value.end -= shortcodesLength;
          }else {
            props.value.text = [props.value.text.slice(0, props.value.end), shortcodeEnd, props.value.text.slice(props.value.end)].join('');
            props.value.text = [props.value.text.slice(0, props.value.start), shortcodeStart, props.value.text.slice(props.value.start)].join('');
            props.value.formats.length += shortcodesLength;
            props.value.replacements.length += shortcodesLength;
            props.value.end += shortcodesLength;
          }
          props.onChange(
            props.value);
        },
        isActive: props.isActive,
      }
    );
  }
  wp.richText.registerFormatType(
    'my-custom-format/speechkit', {
      title: 'SpeechKit',
      tagName: 'speechkit',
      className: null,
      edit: SpeechKitButton,
    }
  );
} )( window.wp );