<?php

$post_status = get_post_meta( get_the_ID(), 'speechkit_status', true );

if ( $post_status ) {
    ?>
<!-- Header -->
<p id="speechkit_status" data-status="<?php echo $post_status; ?>"><?php _e( 'Status', 'speechkit' ); // phpcs:ignore ?>: <b><?php
switch ( $post_status ) {
    case Speechkit_Admin::STATUS_PROCESSING:
        _e( 'Processing', 'speechkit' ); // phpcs:ignore
        break;
    case Speechkit_Admin::STATUS_PROCESSED:
        _e( 'Processed', 'speechkit' ); // phpcs:ignore
        break;
    case Speechkit_Admin::STATUS_ERROR:
        _e( 'Error', 'speechkit' ); // phpcs:ignore
        break;
    case Speechkit_Admin::STATUS_FAILED:
        _e( 'Failed', 'speechkit' ); // phpcs:ignore
        break;
    case Speechkit_Admin::STATUS_SCHEDULED:
        _e( 'Scheduled', 'speechkit' ); // phpcs:ignore
        break;
    default:
        _e( 'New', 'speechkit' ); // phpcs:ignore
        break;
}
?>
</b></p>
<?php
}

$publish_post_to_speechkit = get_post_meta(get_the_ID(), 'publish_post_to_speechkit', true);

switch ( $post_status ) {
    case Speechkit_Admin::STATUS_NEW:
        ?>
        <!-- Update/regenerate -->
        <p><?php _e( 'Audio will be generated automatically shortly. You can press \'Update Audio\' to regenerate manually.', 'speechkit' ); // phpcs:ignore ?></p>
        <button type="button" class="button button-large sk-metabox-button sk_action_button" id="sk_regenerate_action" data-action="sk_regenerate"><?php _e( 'Update Audio', 'speechkit' ); // phpcs:ignore ?></button>
        <hr>
        <?php if(Speechkit_Admin::is_disabled_autopublish()){
            if( empty($publish_post_to_speechkit) ){
                $publish_post_to_speechkit = true;
            }?>
            <p><input type="checkbox" id="publish_post_to_speechkit" name="publish_post_to_speechkit" <?php checked( $publish_post_to_speechkit, 1 ); ?> value="1"> <?php _e( 'Update audio', 'speechkit' ); ?></p>
        <?php }else{ ?>
            <input type="hidden" value="<?php echo $publish_post_to_speechkit; ?>" name="publish_post_to_speechkit" />
        <?php } ?>
        <hr>
        <?php
        break;
    case Speechkit_Admin::STATUS_PROCESSING:
        ?>
        <p><?php _e( 'SpeechKit is currently processing your post.', 'speechkit' ); // phpcs:ignore ?></p>

        <!-- Show/Hide player -->
        <p><?php _e( 'Press Hide audio player/Show audio player to remove audio from this post.', 'speechkit' ); // phpcs:ignore ?></p>
        <button type="button" class="button button-large sk-metabox-button sk_action_button" id="sk_toggle_action" data-action="sk_toggle">
        <?php
        $is_disabled = 1 == get_post_meta( get_the_ID(), 'speechkit_disabled', true );
        if ( $is_disabled ) {
            _e( 'Show Audio Player', 'speechkit' ); // phpcs:ignore
        } else {
            _e( 'Hide Audio Player', 'speechkit' ); // phpcs:ignore
        }
        ?></button>
        <hr>
        <?php if(Speechkit_Admin::is_disabled_autopublish()){
            if( empty($publish_post_to_speechkit) ){
                $publish_post_to_speechkit = true;
            }?>
            <p><input type="checkbox" id="publish_post_to_speechkit" name="publish_post_to_speechkit" <?php checked( $publish_post_to_speechkit, 1 ); ?> value="1"> <?php _e( 'Update audio', 'speechkit' ); ?></p>
        <?php }else{ ?>
            <input type="hidden" value="<?php echo $publish_post_to_speechkit; ?>" name="publish_post_to_speechkit" />
        <?php } ?>
        <hr>
        <?php
        break;
    case Speechkit_Admin::STATUS_PROCESSED:

        $info = get_post_meta( get_the_ID(), 'speechkit_info', true );
        // Find the non transcoded version
        if ( ! empty( $info ) && is_array( $info['media'] ) ) {
            foreach ( $info['media'] as $media ) {
                if ( isset( $media['content_type'] ) && $media['content_type'] != 'application/x-mpegURL' ) {
                    $audio_link = $media['url'];
                    break;
                }
            }
        }
        if ( isset( $audio_link ) ) {
            ?>
            <!-- Listen link -->
            <a href="<?php echo esc_url( $audio_link ); ?>" target="_blank" class="button button-large sk-metabox-button"><?php _e( 'Listen / Download', 'speechkit' ); // phpcs:ignore ?></a>
            <hr>
            <?php
        }
        ?>

        <!-- Show/Hide player -->
        <p><?php _e( 'Press Hide audio player/Show audio player to remove audio from this post.', 'speechkit' ); // phpcs:ignore ?></p>
        <button type="button" class="button button-large sk-metabox-button sk_action_button" id="sk_toggle_action" data-action="sk_toggle"><?php
        $is_disabled = 1 == get_post_meta( get_the_ID(), 'speechkit_disabled', true );
        if ( $is_disabled ) {
            _e( 'Show Audio Player', 'speechkit' ); // phpcs:ignore
        } else {
            _e( 'Hide Audio Player', 'speechkit' ); // phpcs:ignore
        }
        ?></button>
        <hr>

        <!-- Update/regenerate -->
        <p><?php _e( 'Audio will generate automatically. But you can press \'Update Audio\' to regenerate manually.', 'speechkit' ); ?></p>
        <button type="button" class="button button-large sk-metabox-button sk_action_button" id="sk_regenerate_action" data-action="sk_regenerate"><?php _e( 'Update Audio', 'speechkit' ); ?></button>
        <hr>
        <?php if(Speechkit_Admin::is_disabled_autopublish()){
            if( empty($publish_post_to_speechkit) ){
                $publish_post_to_speechkit = true;
            }?>
            <p><input type="checkbox" id="publish_post_to_speechkit" name="publish_post_to_speechkit" <?php checked( $publish_post_to_speechkit, 1 ); ?> value="1"> <?php _e( 'Update audio', 'speechkit' ); ?></p>
        <?php }else{ ?>
            <input type="hidden" value="<?php echo $publish_post_to_speechkit; ?>" name="publish_post_to_speechkit" />
        <?php } ?>
        <hr>
        <?php
        break;
    case Speechkit_Admin::STATUS_FAILED:
    case Speechkit_Admin::STATUS_ERROR:
        ?>
        <p><?php _e( 'Seems like something has gone wrong. Press \'Try Again\' to try to generate the audio again.', 'speechkit' ); ?></p>
        <!-- Update/regenerate -->
        <p><?php _e( 'Press this to manually regenerate audio.', 'speechkit' ); ?></p>
        <button type="button" class="button button-large sk-metabox-button sk_action_button" id="sk_regenerate_action" data-action="sk_regenerate"><?php _e( 'Try Again', 'speechkit' ); ?></button>
        <hr>
        <?php if(Speechkit_Admin::is_disabled_autopublish()){
            if( empty($publish_post_to_speechkit) ){
                $publish_post_to_speechkit = true;
            }?>
            <p><input type="checkbox" id="publish_post_to_speechkit" name="publish_post_to_speechkit" <?php checked( $publish_post_to_speechkit, 1 ); ?> value="1"> <?php _e( 'Update audio', 'speechkit' ); ?></p>
        <?php }else{ ?>
            <input type="hidden" value="<?php echo $publish_post_to_speechkit; ?>" name="publish_post_to_speechkit" />
        <?php } ?>
        <hr>
        <?php
        break;
    case Speechkit_Admin::STATUS_SCHEDULED:
        ?>
        <p><?php _e( 'SpeechKit will produce audio once when publish your post.', 'speechkit' ); // phpcs:ignore ?></p>
        <?php
        break;
    default:
        ?>
        <p><?php _e( 'SpeechKit will produce audio once you publish your post.', 'speechkit' ); // phpcs:ignore ?></p>
        <!-- Generate podcast -->
        <?php
        if( empty( $publish_post_to_speechkit) ){
            $publish_post_to_speechkit = !Speechkit_Admin::is_disabled_autopublish();
        }
        ?>
        <p><input type="checkbox" id="publish_post_to_speechkit" name="publish_post_to_speechkit" <?php checked( $publish_post_to_speechkit, 1 ); ?> value="1"> <?php _e( 'Generate audio', 'speechkit' ); ?></p>
        <?php
        break;
}
?>
<p><?php _e( 'Having trouble? Visit our support page or email us at: <a href="mailto:support@speechkit.io">support@speechkit.io</a>', 'speechkit' ); ?></p>
